Public Class cQueueData

    Public m_nQueueDigitDetectPlayWaveId As Integer
    Public m_nQueuePlayWaveId As Integer

    Public m_bIsDigitDetect As Boolean
    Public m_unQueueId As UInteger

    Public m_objAgentList As New ArrayList
    Public m_objQueueCallList As New ArrayList

    Public m_objDigitDetectList As New Hashtable

    Public Sub New()

        m_nQueueDigitDetectPlayWaveId = -1
        m_unQueueId = 0
        m_nQueuePlayWaveId = -1

    End Sub

End Class

Public Class cQueueList

    Private Const DETECT_DIGIT_TIME_START As Integer = 1
    Private Const DETECT_DIGIT_TIME_UP As Integer = 2

    Dim m_unQueueIdCount As UInteger

    Dim m_objQueueListTEXT As New Hashtable
    Dim m_objQueueListINT As New Hashtable

    Sub New()
        m_unQueueIdCount = 0
    End Sub

    Public Sub UnLoadQueue()
        DeleteAll()
    End Sub

    Public Function ChooseQueueId() As UInteger

        While (True)

            m_unQueueIdCount = m_unQueueIdCount + 1

            If FindQueue(m_unQueueIdCount) Is Nothing Then
                Exit While
            End If

        End While

        ChooseQueueId = m_unQueueIdCount

    End Function

    Public Sub LoadQueue()

        Dim objReg As New cRegistry
        Dim objQueueList As New ArrayList

        If objReg.EnumQueue(objQueueList) = False Then
            Exit Sub
        End If

        Dim objQueueReg As New cQueueReg
        Dim nCount As Integer

        For nCount = 0 To objQueueList.Count - 1

            If objReg.GetQueue(objQueueList(nCount), objQueueReg) = False Then
                cServerSIP.m_objServerSIP.LogStatus("Unable to load queue [ " + objQueueList(nCount) + " ] information from registry.")
                Continue For
            End If

            Add(objQueueList(nCount), objQueueReg.m_sPlayWave, objQueueReg.m_sPressDigitPlayWave, objQueueReg.m_objQueueOPList, objQueueReg.m_objPressDigitList, objQueueReg.m_objPressDigitUserList)

        Next



    End Sub

    Public Function AddQueue(ByVal sQueueName As String, ByVal sQueuePlayWave As String, ByVal sDigitPressPlayWave As String, ByRef objAgentList As ArrayList, ByRef objPressDigitList As ArrayList, ByRef objUserDigitList As ArrayList) As Boolean

        Dim objQueueReg As New cQueueReg

        objQueueReg.m_sPlayWave = sQueuePlayWave
        objQueueReg.m_sPressDigitPlayWave = sDigitPressPlayWave

        objQueueReg.m_objQueueOPList = objAgentList
        objQueueReg.m_objPressDigitList = objPressDigitList
        objQueueReg.m_objPressDigitUserList = objUserDigitList

        Dim objReg As New cRegistry
        If objReg.SetQueue(sQueueName, objQueueReg) = False Then
            AddQueue = False
            Exit Function
        End If

        Add(sQueueName, sQueuePlayWave, sDigitPressPlayWave, objAgentList, objPressDigitList, objUserDigitList)
        AddQueue = True

    End Function

    Public Function RemoveQueue(ByVal sQueueName As String) As Boolean

        Dim objReg As New cRegistry

        If objReg.RemoveQueue(sQueueName) = False Then
            RemoveQueue = False
            Exit Function
        End If

        Remove(sQueueName)
        RemoveQueue = True
    End Function

    Private Function FindFreeUserId(ByRef objListOP As ArrayList, ByRef sFreeUserId As String) As Boolean

        Dim nCount As Integer
        For nCount = 0 To objListOP.Count - 1

            If cServerSIP.m_objServerSIP.m_objUserList.GetCallCount(objListOP(nCount)) = 0 Then
                sFreeUserId = objListOP(nCount)
                FindFreeUserId = True
                Exit Function
            End If

        Next

        FindFreeUserId = False

    End Function

    Private Sub PlayQueueWaveToCall(ByRef objCallData As cCallData, ByVal nQueueWaveId As Integer, ByVal bLoopPlay As Boolean)

        If nQueueWaveId <> -1 Then
            cServerSIP.m_objServerSIP.PlayWaveStartToCall(objCallData, nQueueWaveId, bLoopPlay)
        End If

    End Sub


    Public Function AddCallToQueue(ByRef objCallData As cCallData) As Boolean

        Dim objQueueData As cQueueData = FindQueue(objCallData.m_unQueueId)

        If objQueueData Is Nothing Then
            AddCallToQueue = False
            Exit Function
        End If


        objQueueData.m_objQueueCallList.Add(objCallData)
        objCallData.m_bDigitDetect = objQueueData.m_bIsDigitDetect

        UpdateCall(objCallData, objQueueData)
        AddCallToQueue = True

    End Function

    Private Sub UpdateCall(ByRef objCallData As cCallData, ByRef objQueueData As cQueueData)

        If objCallData.m_bDigitDetect Then

            cServerSIP.m_objServerSIP.EnableDetectDTMF(objCallData)
            PlayQueueWaveToCall(objCallData, objQueueData.m_nQueueDigitDetectPlayWaveId, False)

        Else

            PlayQueueWaveToCall(objCallData, objQueueData.m_nQueuePlayWaveId, True)

            If objQueueData.m_objQueueCallList.Count = 1 Then
                DistributeCall(objQueueData)
            End If

        End If

    End Sub

    Public Sub ProcessQueueTick()

        Dim enumerator As IDictionaryEnumerator = m_objQueueListINT.GetEnumerator()

        While enumerator.MoveNext()

            Dim objQueueData As cQueueData = enumerator.Value
            DistributeCall(objQueueData)

        End While

    End Sub


    Private Sub DistributeCall(ByRef objQueueData As cQueueData)

        Dim objQueueCallData As cCallData

        Dim nCount As Integer
        For nCount = 0 To objQueueData.m_objQueueCallList.Count - 1

            objQueueCallData = objQueueData.m_objQueueCallList(nCount)

            If objQueueCallData.m_bDigitDetect Then

                If DistributeCallToDigitPressUser(objQueueData, objQueueCallData) = False Then
                    Continue For
                End If

            Else

                If DistributeCallToQueueAgent(objQueueData, objQueueCallData) = False Then
                    Exit Sub
                End If

            End If

            objQueueData.m_objQueueCallList.RemoveAt(nCount)

        Next

    End Sub

    Private Function DistributeCallToQueueAgent(ByRef objQueueData As cQueueData, ByRef objQueueCallData As cCallData) As Boolean

        Dim sFreeAgentUserId As String = ""

        If FindFreeUserId(objQueueData.m_objAgentList, sFreeAgentUserId) = False Then
            DistributeCallToQueueAgent = False
            Exit Function
        End If

        Dim objDialCallData As cCallData = cServerSIP.m_objServerSIP.DialCallToUser(objQueueCallData, sFreeAgentUserId)

        If objDialCallData Is Nothing Then
            DistributeCallToQueueAgent = False
            Exit Function
        End If

        PlayDialToneToCall(objQueueCallData)
        DistributeCallToQueueAgent = True

    End Function

    Private Function DistributeCallToDigitPressUser(ByRef objQueueData As cQueueData, ByRef objQueueCallData As cCallData) As Boolean

        If objQueueCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_START Then
            objQueueCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_UP
            DistributeCallToDigitPressUser = False
            Exit Function
        End If

        If objQueueCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_UP Then

            If DialCallToDigitPRESS(objQueueData, objQueueCallData) = True Then
                DistributeCallToDigitPressUser = True
                Exit Function
            End If

            cServerSIP.m_objServerSIP.DisableDetectDTMF(objQueueCallData)
            UpdateCall(objQueueCallData, objQueueData)

        End If

        DistributeCallToDigitPressUser = False

    End Function

    Private Function DialCallToDigitPRESS(ByRef objQueueData As cQueueData, ByRef objQueueCallData As cCallData) As Boolean

        If objQueueCallData.m_sDigitPRESS.Length = 0 Then
            DialCallToDigitPRESS = False
            Exit Function
        End If

        Dim sDigitPressUSER As String = ""

        If FindUserForDigitPRESS(objQueueData, objQueueCallData.m_sDigitPRESS, sDigitPressUSER) = True Then

            Dim objDialCallData As cCallData = cServerSIP.m_objServerSIP.DialCallToUser(objQueueCallData, sDigitPressUSER)

            If Not objDialCallData Is Nothing Then
                cServerSIP.m_objServerSIP.DisableDetectDTMF(objQueueCallData)
                PlayDialToneToCall(objQueueCallData)

                DialCallToDigitPRESS = True
                Exit Function
            End If

        End If

        DialCallToDigitPRESS = False

    End Function


    Private Function FindUserForDigitPRESS(ByRef objQueueData As cQueueData, ByVal sDigitPRESS As String, ByRef sDigitPressUSER As String) As Boolean

        sDigitPressUSER = objQueueData.m_objDigitDetectList.Item(sDigitPRESS)

        If sDigitPressUSER Is Nothing Then
            FindUserForDigitPRESS = False
            Exit Function
        End If

        FindUserForDigitPRESS = True

    End Function

    Public Sub OnPressDigitDTMF(ByRef objCallData As cCallData, ByVal sDigit As String)

        cServerSIP.m_objServerSIP.PlayWaveStopToCall(objCallData)

        objCallData.m_sDigitPRESS += sDigit
        objCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_START

    End Sub

    Public Sub OnPlayWaveDoneToCall(ByRef objCallData As cCallData)
        objCallData.m_nDigitPRESS = DETECT_DIGIT_TIME_START
    End Sub

    Public Sub PlayDialToneToCall(ByRef objCallData As cCallData)

        Dim nDialToneSessionId As Integer = cServerSIP.m_objServerSIP.m_objServerData.GetDialToneSessionId()

        If nDialToneSessionId <> -1 Then
            cServerSIP.m_objServerSIP.AddCallToSession(objCallData, nDialToneSessionId)
        End If

    End Sub

    Public Sub RemoveQueueCall(ByRef objCallData As cCallData)

        Dim objQueueData As cQueueData = FindQueue(objCallData.m_unQueueId)
        If objQueueData Is Nothing Then
            Exit Sub
        End If

        Dim nIndex As Integer = objQueueData.m_objQueueCallList.IndexOf(objCallData)
        If nIndex <> -1 Then
            objQueueData.m_objQueueCallList.RemoveAt(nIndex)
        End If

    End Sub

    Public Function FindQueue(ByVal sQueueName As String) As cQueueData
        FindQueue = m_objQueueListTEXT.Item(sQueueName.ToLower())
    End Function

    Public Function FindQueue(ByVal unQueueId As UInteger) As cQueueData
        FindQueue = m_objQueueListINT.Item(unQueueId)
    End Function

    Public Sub DeleteAll()

        Dim objQueueData As cQueueData
        Dim enumerator As IDictionaryEnumerator = m_objQueueListINT.GetEnumerator()

        While enumerator.MoveNext()
            objQueueData = enumerator.Value
            cServerSIP.m_objServerSIP.PlayWaveUnLoadFile(objQueueData.m_nQueuePlayWaveId)
            cServerSIP.m_objServerSIP.PlayWaveUnLoadFile(objQueueData.m_nQueueDigitDetectPlayWaveId)
        End While

        m_objQueueListTEXT.Clear()
        m_objQueueListINT.Clear()

    End Sub

    Private Sub Remove(ByVal sQueueName As String)

        Dim objQueueData As cQueueData = FindQueue(sQueueName)
        If objQueueData Is Nothing Then
            Exit Sub
        End If

        Dim nCount As Integer
        For nCount = 0 To objQueueData.m_objQueueCallList.Count - 1
            Dim objQueueCallData As cCallData = objQueueData.m_objQueueCallList(nCount)
            cServerSIP.m_objServerSIP.CloseCall(objQueueCallData)
        Next

        m_objQueueListINT.Remove(objQueueData.m_unQueueId)
        m_objQueueListTEXT.Remove(sQueueName.ToLower())

    End Sub

    Private Sub Add(ByVal sQueueName As String, ByVal sQueuePlayWave As String, ByVal sDigitPressPlayWave As String, ByRef objAgentList As ArrayList, ByRef objPressDigitList As ArrayList, ByRef objUserDigitList As ArrayList)

        Remove(sQueueName)

        Dim nPlayWaveId As Integer = -1
        Dim nDigitPressPlayWaveId As Integer = -1

        If sQueuePlayWave.Length <> 0 Then

            cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file....")
            nPlayWaveId = cServerSIP.m_objServerSIP.PlayWaveLoadFile(sQueuePlayWave)

            If nPlayWaveId = -1 Then
                cServerSIP.m_objServerSIP.LogError("")
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file fail.")
            Else
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file done.")
            End If

        End If

        If sDigitPressPlayWave.Length <> 0 Then

            cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sDigitPressPlayWave + " ] wave file....")
            nDigitPressPlayWaveId = cServerSIP.m_objServerSIP.PlayWaveLoadFile(sDigitPressPlayWave)

            If nDigitPressPlayWaveId = -1 Then
                cServerSIP.m_objServerSIP.LogError("")
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file fail.")
            Else
                cServerSIP.m_objServerSIP.LogStatus("Loading [ " + sQueuePlayWave + " ] wave file done.")
            End If

        End If

        Dim objQueueData As New cQueueData

        If objPressDigitList.Count = 0 Then
            objQueueData.m_bIsDigitDetect = False
        Else
            objQueueData.m_bIsDigitDetect = True
        End If

        Dim nCount As Integer

        For nCount = 0 To objAgentList.Count - 1
            objQueueData.m_objAgentList.Add(objAgentList(nCount))
        Next

        For nCount = 0 To objPressDigitList.Count - 1
            objQueueData.m_objDigitDetectList.Add(objPressDigitList(nCount), objUserDigitList(nCount))
        Next

        objQueueData.m_unQueueId = ChooseQueueId()
        objQueueData.m_nQueueDigitDetectPlayWaveId = nDigitPressPlayWaveId
        objQueueData.m_nQueuePlayWaveId = nPlayWaveId

        m_objQueueListINT.Add(objQueueData.m_unQueueId, objQueueData)
        m_objQueueListTEXT.Add(sQueueName.ToLower(), objQueueData)

    End Sub

End Class
