Public Class cServerData

    Private m_nStealthSession As Integer
    Private m_nStealthWaveId As Integer

    Private m_nHoldSession As Integer
    Private m_nHoldPlayWaveId As Integer

    Private m_nDialToneWaveId As Integer
    Private m_nDialToneSession As Integer

    Sub New()

        m_nHoldSession = -1
        m_nHoldPlayWaveId = -1

        m_nDialToneWaveId = -1
        m_nDialToneSession = -1

        m_nStealthSession = -1
        m_nStealthWaveId = -1

    End Sub

    Public Function GetDialToneSessionId() As Integer
        GetDialToneSessionId = m_nDialToneSession
    End Function

    Public Function GetStealthSessionId() As Integer
        GetStealthSessionId = m_nStealthSession
    End Function

    Public Function GetHoldSessionId() As Integer
        GetHoldSessionId = m_nHoldSession
    End Function

    Public Sub LoadWavFiles()

        Dim objReg As New cRegistry

        Dim sHoldMusicWaveFile As String = objReg.GetHoldMusic()
        Dim sDialToneWaveFile As String = objReg.GetDialToneMusic()
        Dim sStealthMusicWaveFile As String = objReg.GetStealthListenerMusic()

        If sHoldMusicWaveFile.Length <> 0 Then
            cServerSIP.m_objServerSIP.LoadWaveFileToSession(sHoldMusicWaveFile, m_nHoldPlayWaveId, m_nHoldSession)
        End If

        If sDialToneWaveFile.Length <> 0 Then
            cServerSIP.m_objServerSIP.LoadWaveFileToSession(sDialToneWaveFile, m_nDialToneWaveId, m_nDialToneSession)
        End If

        If sStealthMusicWaveFile.Length <> 0 Then
            cServerSIP.m_objServerSIP.LoadWaveFileToSession(sStealthMusicWaveFile, m_nStealthWaveId, m_nStealthSession)
        End If

    End Sub

    Public Sub UnLoadWavFiles()

        cServerSIP.m_objServerSIP.UnLoadWaveFileToSession(m_nHoldPlayWaveId, m_nHoldSession)
        cServerSIP.m_objServerSIP.UnLoadWaveFileToSession(m_nDialToneWaveId, m_nDialToneSession)
        cServerSIP.m_objServerSIP.UnLoadWaveFileToSession(m_nStealthWaveId, m_nStealthSession)

    End Sub

    Public Sub LoadServer()

        LoadWavFiles()

        cServerSIP.m_objServerSIP.m_objLineList.LoadLines()
        cServerSIP.m_objServerSIP.m_objDialPlanList.LoadDialPlans()
        cServerSIP.m_objServerSIP.m_objQueueList.LoadQueue()

        cServerSIP.m_objServerSIP.SetVaxTeleTick(cServerSIP.QUEUE_TICK_ID, 2000) '2 seconds.

    End Sub

    Public Sub UnLoadServer()

        UnLoadWavFiles()

        cServerSIP.m_objServerSIP.m_objLineList.UnLoadLines()
        cServerSIP.m_objServerSIP.m_objDialPlanList.UnLoadDialPlans()
        cServerSIP.m_objServerSIP.m_objQueueList.UnLoadQueue()

        cServerSIP.m_objServerSIP.KillVaxTeleTick(cServerSIP.QUEUE_TICK_ID)

    End Sub


End Class
