
Public Class cStealthList

    Dim m_unStealthIdCount As UInteger

    Private m_objStealthListINT As New Hashtable
    Private m_objStealthListTEXT As New Hashtable

    Sub New()
        m_unStealthIdCount = 0
    End Sub

    Public Function ChooseStealthId() As UInteger

        While (True)
            m_unStealthIdCount += 1

            If FindStealthCall(m_unStealthIdCount) Is Nothing Then
                Exit While
            End If
        End While

        ChooseStealthId = m_unStealthIdCount

    End Function

    Public Sub AddCallToStealthList(ByRef objCallData As cCallData)

        objCallData.m_unStealthId = ChooseStealthId()

        m_objStealthListINT.Add(objCallData.m_unStealthId, objCallData)
        m_objStealthListTEXT.Add(objCallData.m_sStealthDialNo, objCallData)

    End Sub

    Public Sub FreeCaptureCall(ByRef objCallData As cCallData)

        If objCallData.m_unStealthId <> 0 Then

            Dim objStealthCallData As cCallData = FindStealthCall(objCallData.m_unStealthId)

            If Not objStealthCallData Is Nothing Then
                objStealthCallData.m_bStealthListening = False

                Dim nStealthSessionId As Integer = cServerSIP.m_objServerSIP.m_objServerData.GetStealthSessionId()
                cServerSIP.m_objServerSIP.AddCallToSession(objStealthCallData, nStealthSessionId)
            End If

	    End If
	
    End Sub

    Public Sub TryCaptureCall(ByRef objCallData As cCallData)

        Dim objStealthCallData As cCallData = FindStealthCall(objCallData.m_sUserId)

        If objStealthCallData Is Nothing Then
            Exit Sub
        End If

        If objStealthCallData.m_bStealthListening = True Then
            Exit Sub
        End If

        cServerSIP.m_objServerSIP.AddCallToSession(objStealthCallData, objCallData.m_nSessionId)

        objStealthCallData.m_bStealthListening = True
        objCallData.m_unStealthId = objStealthCallData.m_unStealthId

    End Sub

    Public Function FindStealthCall(ByVal unStealthId As UInteger) As cCallData
        FindStealthCall = m_objStealthListINT.Item(unStealthId)
    End Function

    Public Function FindStealthCall(ByVal sDialNo As String) As cCallData
        FindStealthCall = m_objStealthListTEXT.Item(sDialNo.ToLower())
    End Function

    Public Sub RemoveStealthCall(ByRef objCallData As cCallData)
        m_objStealthListINT.Remove(objCallData.m_unStealthId)
        m_objStealthListTEXT.Remove(objCallData.m_sStealthDialNo)
    End Sub

    Public Sub DeleteAll()
        m_objStealthListTEXT.Clear()
        m_objStealthListINT.Clear()
    End Sub

End Class
