#include "StdAfx.h"
#include "DialPlanList.h"
#include "Registry.h"


cDialPlanData::cDialPlanData()
{
	m_nUserPrefixSize = 0;
	m_sUserPrefix = gcnew String("");
	m_sLineName = gcnew String("");
	m_sCallPrefix = gcnew String("");
}

cDialPlanList::cDialPlanList(void)
{
	m_objDialPlanList = gcnew ArrayList();
}

void cDialPlanList::ReLoadDialPlans()
{
    UnLoadDialPlans();
    LoadDialPlans();
}

void cDialPlanList::UnLoadDialPlans()
{
    m_objDialPlanList->Clear();
}

void cDialPlanList::LoadDialPlans()
{
    m_objDialPlanList->Clear();

    ArrayList^ objDialPlanList = gcnew ArrayList();
    
    cRegistry^ objReg = gcnew cRegistry();
    if (objReg->EnumDialPlan(objDialPlanList) == false)
        return;
    
    cDialPlanReg^ objDialPlanReg = gcnew cDialPlanReg();

    for (int nCount = 0; nCount < objDialPlanList->Count; nCount++)
    {
        if (objReg->GetDialPlan((String^) objDialPlanList[nCount], objDialPlanReg) == false)
            continue;

        cDialPlanData^ objDialPlanData = gcnew cDialPlanData();

        objDialPlanData->m_sLineName = objDialPlanReg->m_sLineName;
        objDialPlanData->m_sCallPrefix = objDialPlanReg->m_sCallPrefix;

        objDialPlanData->m_sUserPrefix = (String^)objDialPlanList[nCount];
        objDialPlanData->m_nUserPrefixSize = ((String^)objDialPlanList[nCount])->Length;

        m_objDialPlanList->Add(objDialPlanData);
    }
}

int cDialPlanList::SearchDialPlan(String^ sCallTo)
{
    int nCallToLen = sCallTo->Length;

    for (int nCount = 0; nCount < m_objDialPlanList->Count; nCount++)
    {
        cDialPlanData^ objDialPlanData = (cDialPlanData^) m_objDialPlanList[nCount];
        int nPrefixLen = objDialPlanData->m_nUserPrefixSize;

        if (nCallToLen <= objDialPlanData->m_nUserPrefixSize)
            continue;

        if (sCallTo->Substring(0, objDialPlanData->m_nUserPrefixSize) == objDialPlanData->m_sUserPrefix)
            return nCount;
    }

    return -1;
}

String^ cDialPlanList::ApplyDialPlan(int nDialPlanIndex, String^ sCallTo, String^ sLineName)
{
    cDialPlanData^ objDialPlanData = (cDialPlanData^) m_objDialPlanList[nDialPlanIndex];
    sCallTo = sCallTo->Remove(0, objDialPlanData->m_nUserPrefixSize);

    sLineName = objDialPlanData->m_sLineName;
           
    if (objDialPlanData->m_sCallPrefix->Length == 0)
        return sCallTo;

    return (objDialPlanData->m_sCallPrefix + sCallTo);
}
