#include "StdAfx.h"
#include "ErrorLog.h"
#include "ServerSIP.h"
#include "TelnetServer.h"

cErrorLog::cErrorLog(void)
{
}

void cErrorLog::LogError(String^ sError)
{
    if(sError->Length == 0)
    {
        SendError();
    }
    else
    {
        ArrayList^ objParamList = gcnew ArrayList();
        objParamList->Add(sError);

		cTelnetServer::m_objTelnetServer->SendCommandToAll("ErrorLog", objParamList);
    }
}

void cErrorLog::SendError()
{
    String^ sErrorText = gcnew String("");

	int nVaxErrorCode = cServerSIP::m_objServerSIP->GetVaxObjectError();
	
    switch(nVaxErrorCode)
    {
	    case 200:
		    sErrorText = "Fail to initialize RTP Socket.";
	    break;

	    case 201:
		    sErrorText = "Fail to allocate RTP port or RTP listen IP is not correct.";
	    break;

	    case 202:
		    sErrorText = "Fail to create RTP task manager.";
	    break;

	    case 203:
		    sErrorText = "Fail to start media thread.";
	    break;

	    case 204:
		    sErrorText = "Fail to create RTP communication manager.";
	    break;

	    case 205:
		    sErrorText = "Unable to use RTP communication manager.";
	    break;

	    case 206:
		    sErrorText = "Unable to open file.";
	    break;

	    case 207:
		    sErrorText = "Unable to read file.";
	    break;

	    case 208:
		    sErrorText = "Wave file format is not correct, please use 8000Hz, 16bit, mono uncompressed wave file.";
	    break;

	    case 209:
		    sErrorText = "Invalid play wave ID.";
	    break;

	    case 210:
		    sErrorText = "Fail to start recording manager.";
	    break;

	    case 211:
		    sErrorText = "Call is not in the voice session.";
	    break;

	    case 212:
		    sErrorText = "Fail to initialize VaxTele object.";
	    break;

	    case 213:
		    sErrorText = "Error to create SDP body.";
	    break;

	    case 214:
		    sErrorText = "Error to create INVITE request.";
	    break;

	    case 215:
		    sErrorText = "Error to initialize SIP communication layer.";
	    break;

	    case 216:
		    sErrorText = "Error to open SIP listen port or SIP listen IP is not correct.";
	    break;

	    case 217:
		    sErrorText = "Error to create SIP task manager.";
	    break;

	    case 218:
		    sErrorText = "Error to create REGISTER request.";
	    break;

	    case 219:
		    sErrorText = "Error to create UN-REGISTER request.";
	    break;

	    case 220:
		    sErrorText = "Error to create BYE request.";
	    break;

	    case 221:
		    sErrorText = "Error to create CANCEL request.";
	    break;

	    case 222:
		    sErrorText = "Call-Id is not valid or call does not exist.";
	    break;

	    case 223:
		    sErrorText = "Session-Id is not valid or session does not exist.";
	    break;

	    case 224:
		    sErrorText = "Login does not exist.";
	    break;

	    case 225:
		    sErrorText = "Login length is not correct.";
	    break;

	    case 226:
		    sErrorText = "Line does not exist.";
	    break;

	    case 227:
		    sErrorText = "Cann't send SIP response.";
	    break;

	    case 228:
		    sErrorText = "SIP response code is not valid, please check SIP RFC 3261.";
	    break;

	    case 229:
		    sErrorText = "Error to create SIP message.";
	    break;

	    case 230:
		    sErrorText = "Line already exist.";
	    break;

	    case 231:
		    sErrorText = "Reg-Id is not correct or does not exist.";
	    break;

	    case 232:
		    sErrorText = "Error to create SIP reponse.";
	    break;

	    case 233:
		    sErrorText = "User is not registered.";
	    break;

	    case 234:
		    sErrorText = "Invalid codec OR there is no codec found for voice streaming.";
	    break;

	    case 235:
		    sErrorText = "Invalid DTMF type.";
	    break;

	    case 236:
		    sErrorText = "Other party does not support RFC2833 DTMF digits.";
	    break;
		
	    case 237:
		    sErrorText = "Error to create REFER request to transfer the call.";
	    break;

	    case 238:
		    sErrorText = "Error to create event handler.";
	    break;

	    case 239:
		    sErrorText = "Invalid license key.";
	    break;

	    case 240:
		    sErrorText = "Invalid digit for DTMF.";
	    break;

	    case 241:
		    sErrorText = "Invalid proxy URI.";
	    break;

	    case 242:
		    sErrorText = "Line is not register.";
	    break;

	    default:
		    return;
    }
    	    
	String^ sError = gcnew String(Convert::ToString(nVaxErrorCode) + " : " + sErrorText);

    ArrayList^ objParamList = gcnew ArrayList();
    objParamList->Add(sError);

	cTelnetServer::m_objTelnetServer->SendCommandToAll("ErrorLog", objParamList);
}