// AddLineDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "VaxTeleConfigDlg.h"
#include "AddLineDlg.h"
#include "Codec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define IN_BOUND_CALL_REJECT			0
#define IN_BOUND_CALL_CONNECT_USER		1
#define IN_BOUND_CALL_PUT_IN_QUEUE		2

/////////////////////////////////////////////////////////////////////////////
// CAddLineDlg dialog


CAddLineDlg::CAddLineDlg() : CPropertyPage(CAddLineDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddLineDlg)
	m_sLineDisplayName = _T("");
	m_sLineUserName = _T("");
	m_sLineAuthUser = _T("");
	m_sLinePassword = _T("");
	m_sLineRealm = _T("");
	m_sLineProxy = _T("");
	m_sLineOutboundProxy = _T("");
	m_bStartupReg = FALSE;
	m_sLineName = _T("");
	m_nRadioCtrlInboundCall = 0;
	//}}AFX_DATA_INIT

	//m_bReLoadLines = FALSE;

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}


void CAddLineDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddLineDlg)
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_USER, m_ctrlComboConnectToLogin);
	DDX_Control(pDX, IDC_COMBO_LINE, m_ctrlComboLine);
	DDX_Control(pDX, IDC_LIST_LINE_DISABLE_CODEC, m_ctrlDisableCodecList);
	DDX_Control(pDX, IDC_LIST_LINE_ENABLE_CODEC, m_ctrlEnableCodecList);
	DDX_Control(pDX, IDC_COMBO_LINE_PUT_QUEUE, m_ctrlComboPutInQueue);
	DDX_Text(pDX, IDC_EDIT_LINE_DISPLAY_NAME, m_sLineDisplayName);
	DDX_Text(pDX, IDC_EDIT_LINE_USER_NAME, m_sLineUserName);
	DDX_Text(pDX, IDC_EDIT_LINE_AUTH_USER, m_sLineAuthUser);
	DDX_Text(pDX, IDC_EDIT_LINE_PASSWORD, m_sLinePassword);
	DDX_Text(pDX, IDC_EDIT_LINE_DOMAIN_REALM, m_sLineRealm);
	DDX_Text(pDX, IDC_EDIT_LINE_SIP_PROXY, m_sLineProxy);
	DDX_Text(pDX, IDC_EDIT_LINE_OUTBOUND_PROXY, m_sLineOutboundProxy);
	DDX_Check(pDX, IDC_CHECK_REG_START_UP, m_bStartupReg);
	DDX_CBString(pDX, IDC_COMBO_LINE, m_sLineName);
	DDX_Radio(pDX, IDC_RADIO_INBOUND_REJECT, m_nRadioCtrlInboundCall);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddLineDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddLineDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_LINE, OnSelchangeComboLine)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_LINE_DLG, OnButtonClearLineDlg)
	ON_BN_CLICKED(IDC_BUTTON_LINE_DISABLE_CODEC, OnButtonLineDisableCodec)
	ON_BN_CLICKED(IDC_BUTTON_LINE_ENABLE_CODEC, OnButtonLineEnableCodec)
	ON_BN_CLICKED(IDC_BUTTON_LINE_ADD, OnButtonLineAdd)
	ON_BN_CLICKED(IDC_BUTTON_LINE_REMOVE, OnButtonLineRemove)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddLineDlg message handlers

BOOL CAddLineDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ctrlComboLine.SetWindowPos(NULL,0,0,140,150,SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboConnectToLogin.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboPutInQueue.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("ShowLines", NULL);
				
	ClearDlgContent();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddLineDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "AddUser") == 0 && pParamList->GetCount() == 1)
	{
		CString objLogin = pParamList->GetHead();
		m_ctrlComboConnectToLogin.AddString(objLogin);
				
		return;
	}
	
	if(::lstrcmpi(sCommand, "RemoveUser") == 0 && pParamList->GetCount() == 1)
	{
		int nIndex = m_ctrlComboConnectToLogin.FindStringExact(0, pParamList->GetHead());
		if(nIndex != -1) m_ctrlComboConnectToLogin.DeleteString(nIndex);
						
		return;
	}
	
	if(::lstrcmpi(sCommand, "AddQueue") == 0 && pParamList->GetCount() == 1)
	{
		CString objQueue = pParamList->GetHead();
		m_ctrlComboPutInQueue.AddString(objQueue);
				
		return;
	}

	if(::lstrcmpi(sCommand, "RemoveQueue") == 0 && pParamList->GetCount() == 1)
	{
		int nIndex = m_ctrlComboPutInQueue.FindStringExact(0, pParamList->GetHead());
		if(nIndex != -1) m_ctrlComboPutInQueue.DeleteString(nIndex);
						
		return;
	}

	if(::lstrcmpi(sCommand, "ShowQueues") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objQueue = pParamList->GetAt(pParamList->FindIndex(nCount));
			m_ctrlComboPutInQueue.AddString(objQueue);
		}

		m_ctrlComboPutInQueue.SetCurSel(0);

		return;
	}
	
	if(::lstrcmpi(sCommand, "ShowUsers") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objLogin = pParamList->GetAt(pParamList->FindIndex(nCount));
			m_ctrlComboConnectToLogin.AddString(objLogin);
		}

		m_ctrlComboConnectToLogin.SetCurSel(0);

		return;
	}
	
	if(::lstrcmpi(sCommand, "ShowLines") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objLine = pParamList->GetAt(pParamList->FindIndex(nCount));
			m_ctrlComboLine.AddString(objLine);
		}

		return;
	}

	if(::lstrcmpi(sCommand, "LineInfo") == 0 && pParamList->GetCount() == 12)
	{
		
		CString objLineName		 = pParamList->GetAt(pParamList->FindIndex(0));
		CString objDisplayName   = pParamList->GetAt(pParamList->FindIndex(1));
		CString objUserName      = pParamList->GetAt(pParamList->FindIndex(2));
		CString objAuthUser      = pParamList->GetAt(pParamList->FindIndex(3));
		CString objAuthPwd		 = pParamList->GetAt(pParamList->FindIndex(4));
		CString objRealm		 = pParamList->GetAt(pParamList->FindIndex(5));
		CString objProxy		 = pParamList->GetAt(pParamList->FindIndex(6));
		CString objOutboundProxy = pParamList->GetAt(pParamList->FindIndex(7));
    
		CString objCodecList     = pParamList->GetAt(pParamList->FindIndex(8));

		CString objRegister      = pParamList->GetAt(pParamList->FindIndex(9));
		CString	objInCallType    = pParamList->GetAt(pParamList->FindIndex(10));
		CString objInCallTo      = pParamList->GetAt(pParamList->FindIndex(11));
		
		UpdateDlgContent(objLineName, objDisplayName, objUserName, objAuthUser, objAuthPwd, objRealm, objProxy, objOutboundProxy, objCodecList, objRegister, objInCallType, objInCallTo);

		return;
	}

	if(::lstrcmpi(sCommand, "RemoveLine") == 0 && pParamList->GetCount() == 1)
	{
		int nIndex = m_ctrlComboLine.FindStringExact(0, pParamList->GetHead());
		
		if(nIndex != -1)
			m_ctrlComboLine.DeleteString(nIndex);
	
		MessageBox("Line removed successfully!", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		ClearDlgContent();
		return;
	}

	if(::lstrcmpi(sCommand, "AddLine") == 0 && pParamList->GetCount() == 1)
	{
		CString objLine = pParamList->GetHead();
		m_ctrlComboLine.AddString(objLine);

		MessageBox("Line created successfully", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateLine") == 0 && pParamList->GetCount() == 1)
	{
		MessageBox("Line updated successfully", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}

}

void CAddLineDlg::OnSelchangeComboLine() 
{
	int nCurIndex = m_ctrlComboLine.GetCurSel();
	if(nCurIndex == -1) return;

	m_ctrlComboLine.GetLBText(nCurIndex, m_sLineName);
		
	CStringList objParamList;
	objParamList.AddTail(m_sLineName);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("LineInfo", &objParamList);
	
}

void CAddLineDlg::UpdateIncomingCallSection(int nInCallType, LPCTSTR sInCallTo)
{
	m_nRadioCtrlInboundCall = nInCallType;

	if(nInCallType == IN_BOUND_CALL_CONNECT_USER)
	{
		int nIndex = m_ctrlComboConnectToLogin.FindStringExact(0, sInCallTo);
		
		if(nIndex == -1)
		{
			m_nRadioCtrlInboundCall = IN_BOUND_CALL_REJECT;
			return;
		}
		
		m_ctrlComboConnectToLogin.SelectString(0, sInCallTo);
	}

	else if(nInCallType == IN_BOUND_CALL_PUT_IN_QUEUE)
	{
		int nIndex = m_ctrlComboPutInQueue.FindStringExact(0, sInCallTo);

		if(nIndex == -1)
		{
			m_nRadioCtrlInboundCall = IN_BOUND_CALL_REJECT;
			return;
		}
		
		m_ctrlComboPutInQueue.SelectString(0, sInCallTo);
	}
}

void CAddLineDlg::UpdateDlgContent(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sRealm, LPCTSTR sProxy, LPCTSTR sOutboundProxy, CString objCodecList, LPCTSTR sRegister, LPCTSTR sInCallType, LPCTSTR sInCallTo) 
{
	UpdateData();

	if(m_sLineName != sLineName)  return;

	m_sLineDisplayName	  = sDisplayName;
	m_sLineUserName		  = sUserName;
	m_sLineAuthUser		  = sAuthUser;
	m_sLinePassword		  = sAuthPwd;
	m_sLineRealm		  = sRealm;
	m_sLineProxy		  = sProxy;
	m_sLineOutboundProxy  = sOutboundProxy;
	
	m_bStartupReg		  = (CString(sRegister) == "REGISTER-YES");

	UpdateIncomingCallSection((int) atol(sInCallType), sInCallTo);
		
	CCodec objCodec;
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(char cCodec = '0'; cCodec < TOTAL_NO_CODEC; cCodec++)	
		m_ctrlDisableCodecList.AddString(objCodec.GetCodecName(cCodec));
		
	for(int nCount = 0; nCount < objCodecList.GetLength(); nCount++)
	{
		CString sCodecName = objCodec.GetCodecName(objCodecList.GetAt(nCount));
		m_ctrlEnableCodecList.AddString(sCodecName);
		
		int nIndex = m_ctrlDisableCodecList.FindStringExact(0, sCodecName);
		if(nIndex == -1) continue;
		
		m_ctrlDisableCodecList.DeleteString(nIndex);
	}
			
	UpdateData(FALSE);
}

void CAddLineDlg::OnButtonClearLineDlg() 
{
	ClearDlgContent();
}

void CAddLineDlg::ClearDlgContent()
{

	m_ctrlComboPutInQueue.SetCurSel(0);
	m_ctrlComboConnectToLogin.SetCurSel(0);
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	m_ctrlEnableCodecList.AddString(G711U_TEXT);
	m_ctrlEnableCodecList.AddString(G711A_TEXT);
	m_ctrlEnableCodecList.AddString(ILBC_TEXT);
	m_ctrlEnableCodecList.AddString(G610_TEXT);
	m_ctrlEnableCodecList.AddString(G729_TEXT);

	m_sLineName	           = "";
	m_sLineDisplayName	   = "";
	m_sLineUserName		   = "";
	m_sLineAuthUser		   = "";
	m_sLinePassword		   = "";
	m_sLineRealm		   = "";
	m_sLineProxy		   = "";
	m_sLineOutboundProxy   = "";
	m_bStartupReg		   = FALSE;
	
	m_nRadioCtrlInboundCall = 0;
	
	UpdateData(FALSE);
}


void CAddLineDlg::OnButtonLineDisableCodec() 
{
	int nCurSel = m_ctrlEnableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	m_ctrlEnableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlEnableCodecList.DeleteString(nCurSel);
	
	m_ctrlDisableCodecList.AddString(sCurSelText);
	
}

void CAddLineDlg::OnButtonLineEnableCodec() 
{
	int nCurSel = m_ctrlDisableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	
	m_ctrlDisableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlDisableCodecList.DeleteString(nCurSel);
	
	m_ctrlEnableCodecList.AddString(sCurSelText);
	
}

void CAddLineDlg::OnButtonLineAdd() 
{
	UpdateData();
	
	CString sInCallTo;
	if(!AddLineChecks(sInCallTo))
		return;
	
	if(m_ctrlComboLine.FindStringExact(0, m_sLineName) != -1)
	{
		if(MessageBox("Line already exist, do you want to update it?", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_YESNO) == IDNO)
			return;
	}
	
	CCodec objCodec;
	CString objCodecList;
		
	for(int nCount = 0; nCount < m_ctrlEnableCodecList.GetCount(); nCount++)
	{
		CString sCodecText;
		m_ctrlEnableCodecList.GetText(nCount, sCodecText);

		objCodecList += objCodec.GetCodecNo(sCodecText);
	}

	CStringList objParamList;

	objParamList.AddTail(m_sLineName);
	objParamList.AddTail(m_sLineDisplayName);
	objParamList.AddTail(m_sLineUserName);
	objParamList.AddTail(m_sLineAuthUser);
	objParamList.AddTail(m_sLinePassword);
	objParamList.AddTail(m_sLineRealm);
	objParamList.AddTail(m_sLineProxy);
	objParamList.AddTail(m_sLineOutboundProxy);
	
	objParamList.AddTail(objCodecList);

	if(m_bStartupReg)
		objParamList.AddTail("REGISTER-YES");
	else
		objParamList.AddTail("REGISTER-NO");

	CString sInCallType;
	sInCallType.Format("%d", m_nRadioCtrlInboundCall);

	objParamList.AddTail(sInCallType);
	objParamList.AddTail(sInCallTo);
				
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("AddLine", &objParamList);
}


BOOL CAddLineDlg::AddLineChecks(CString& sInCallTo)
{
	if(m_sLineName.IsEmpty())
	{
		MessageBox("Please enter Line Name.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
		
	if(m_ctrlEnableCodecList.GetCount() == 0)
	{
		MessageBox("Please select a codec.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(m_nRadioCtrlInboundCall == 1)
	{
		int nCurSel = m_ctrlComboConnectToLogin.GetCurSel();
		if(nCurSel == -1) 
		{
			MessageBox("Please select the user/login to forward the incoming call.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
			return FALSE;
		}

		m_ctrlComboConnectToLogin.GetLBText(nCurSel, sInCallTo);
	}

	else if(m_nRadioCtrlInboundCall == 2)
	{
		int nCurSel = m_ctrlComboPutInQueue.GetCurSel();
		if(nCurSel == -1) 
		{
			MessageBox("Please select the queue to put the incoming call.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
			return FALSE;
		}

		m_ctrlComboPutInQueue.GetLBText(nCurSel, sInCallTo);
	}

	return TRUE;
}


void CAddLineDlg::OnButtonLineRemove() 
{
	UpdateData();
	
	if(m_sLineName.IsEmpty())
	{
		MessageBox("Please enter the line name.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	CStringList objParamList;
	objParamList.AddTail(m_sLineName);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("RemoveLine", &objParamList);
	
}

void CAddLineDlg::OnDestroy() 
{
	CPropertyPage::OnDestroy();
	
	/*
	if(m_bReLoadLines)
	{
		HANDLE hWaitEventLoadLines = ::CreateEvent(NULL, FALSE, FALSE, RE_LOAD_LINES_MSG);	
	
		::SetEvent(hWaitEventLoadLines);
		::CloseHandle(hWaitEventLoadLines);
	}
	*/
}
