// AddQueueDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "VaxTeleConfigDlg.h"
#include "AddQueueDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define RE_LOAD_QUEUES_MSG	"VaxTeleConfigLoadQueues"

/////////////////////////////////////////////////////////////////////////////
// CAddQueueDlg dialog


CAddQueueDlg::CAddQueueDlg() : CPropertyPage(CAddQueueDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddQueueDlg)
	m_sQueueName = _T("");
	m_sDigitDetectPress = _T("");
	m_sDigitDetectLogin = _T("");
	m_sDigitPressPlayWave = _T("");
	m_sQueuePlayWave = _T("");
	//}}AFX_DATA_INIT

	//m_bReLoadQueues = FALSE;

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}


void CAddQueueDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddQueueDlg)
	DDX_Control(pDX, IDC_COMBO_QUEUE_DIGITS_USER, m_ctrlComboDigitLogin);
	DDX_Control(pDX, IDC_LIST_QUEUE_PRESS_DIGIT_LIST, m_ctrlDigitPressList);
	DDX_Control(pDX, IDC_COMBO_QUEUE_NAME, m_ctrlComboQueue);
	DDX_Control(pDX, IDC_COMBO_QUEUE_OPERATOR, m_ctrlComboLogin);
	DDX_Control(pDX, IDC_LIST_OPERATOR, m_ctrlListOP);
	DDX_CBString(pDX, IDC_COMBO_QUEUE_NAME, m_sQueueName);
	DDX_Text(pDX, IDC_EDIT_QUEUE_PRESS_DIGITS, m_sDigitDetectPress);
	DDX_CBString(pDX, IDC_COMBO_QUEUE_DIGITS_USER, m_sDigitDetectLogin);
	DDX_Text(pDX, IDC_EDIT_QUEUE_DIGIT_PRESS_PLAY_WAVE, m_sDigitPressPlayWave);
	DDX_Text(pDX, IDC_EDIT_QUEUE_PLAY_WAVE, m_sQueuePlayWave);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddQueueDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddQueueDlg)
	ON_BN_CLICKED(IDC_BUTTON_ADD_LOGIN_TO_QUEUE, OnButtonAddLoginToQueue)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_LOGIN_TO_QUEUE, OnButtonRemoveLoginToQueue)
	ON_BN_CLICKED(IDC_BUTTON_QUEUE_ADD, OnButtonQueueAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_QUEUE, OnButtonRemoveQueue)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_CBN_SELCHANGE(IDC_COMBO_QUEUE_NAME, OnSelchangeComboQueueName)
	ON_BN_CLICKED(IDC_BUTTON_ADD_DIGIT_DETECT, OnButtonAddDigitDetect)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_DIGIT_DETECT, OnButtonRemoveDigitDetect)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddQueueDlg message handlers

BOOL CAddQueueDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ctrlComboQueue.SetWindowPos(NULL,0,0,187,150,SWP_NOMOVE|SWP_NOZORDER);
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("ShowQueues", NULL);

	//////////////////////////////////////////////////////////////////
	
	m_ctrlComboLogin.SetWindowPos(NULL,0,0,140,150,SWP_NOMOVE|SWP_NOZORDER);
		
	m_ctrlDigitPressList.InsertColumn(0, "Digits", LVCFMT_LEFT, 90);
	m_ctrlDigitPressList.InsertColumn(1, "Logins", LVCFMT_LEFT, 150);

	m_ctrlComboDigitLogin.SetWindowPos(NULL,0,0,105,150,SWP_NOMOVE|SWP_NOZORDER);
		
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddQueueDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "AddUser") == 0 && pParamList->GetCount() == 1)
	{
		CString objLogin = pParamList->GetHead();
		
		m_ctrlComboLogin.AddString(objLogin);
		m_ctrlComboDigitLogin.AddString(objLogin);
		
		return;
	}
	
	if(::lstrcmpi(sCommand, "RemoveUser") == 0 && pParamList->GetCount() == 1)
	{
		CString objLogin = pParamList->GetHead();

		int nIndex = m_ctrlComboLogin.FindStringExact(0, objLogin);
		if(nIndex != -1) m_ctrlComboLogin.DeleteString(nIndex);

		nIndex = m_ctrlComboDigitLogin.FindStringExact(0, objLogin);
		if(nIndex != -1) m_ctrlComboDigitLogin.DeleteString(nIndex);
						
		return;
	}
	
	if(::lstrcmpi(sCommand, "ShowUsers") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objLogin = pParamList->GetAt(pParamList->FindIndex(nCount));

			m_ctrlComboLogin.AddString(objLogin);
			m_ctrlComboDigitLogin.AddString(objLogin);
		}

		m_ctrlComboLogin.SetCurSel(0);
		m_ctrlComboDigitLogin.SetCurSel(0);

		return;
	}
	
	if(::lstrcmpi(sCommand, "ShowQueues") == 0)
	{
		for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
		{
			CString objQueue = pParamList->GetAt(pParamList->FindIndex(nCount));
			m_ctrlComboQueue.AddString(objQueue);
		}

		m_ctrlComboQueue.SetCurSel(0);

		return;
	}

	if(::lstrcmpi(sCommand, "QueueInfo") == 0 && pParamList->GetCount() == 6)
	{
		CString objQueue              = pParamList->GetAt(pParamList->FindIndex(0));
		CString objPlayWave           = pParamList->GetAt(pParamList->FindIndex(1));
		CString objDigitPlayWave      = pParamList->GetAt(pParamList->FindIndex(2));
		CString objQueueOPList        = pParamList->GetAt(pParamList->FindIndex(3));
		CString objPressDigitList     = pParamList->GetAt(pParamList->FindIndex(4));
		CString objPressDigitUserList = pParamList->GetAt(pParamList->FindIndex(5));
				
		UpdateDlgContent(objQueue, objPlayWave, objDigitPlayWave, objQueueOPList, objPressDigitList, objPressDigitUserList);

		return;
	}

	if(::lstrcmpi(sCommand, "RemoveQueue") == 0 && pParamList->GetCount() == 1)
	{
		int nIndex = m_ctrlComboQueue.FindStringExact(0, pParamList->GetHead());
		
		if(nIndex != -1)
			m_ctrlComboQueue.DeleteString(nIndex);
	
		MessageBox("Queue removed successfully!", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		ClearDlgContent();

		return;
	}

	if(::lstrcmpi(sCommand, "AddQueue") == 0 && pParamList->GetCount() == 1)
	{
		CString objQueue = pParamList->GetHead();
		m_ctrlComboQueue.AddString(objQueue);

		MessageBox("Queue created successfully", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateQueue") == 0 && pParamList->GetCount() == 1)
	{
		MessageBox("Queue updated successfully", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}
}

void CAddQueueDlg::OnButtonQueueAdd() 
{
	UpdateData();

	if(m_sQueueName.IsEmpty())
	{
		MessageBox("Please enter queue name.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	if(m_ctrlComboQueue.FindStringExact(0, m_sQueueName) != -1)
	{
		if(MessageBox("Queue already exist, do you want to update it?", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_YESNO) == IDNO)
			return;
	}	
		
	int nCount;
	CString sText;

	CString objQueueOPList;
	for(nCount = 0; nCount < m_ctrlListOP.GetCount(); nCount++)
	{
		m_ctrlListOP.GetText(nCount, sText);
		objQueueOPList = objQueueOPList + sText + ",";
	}
	objQueueOPList.Delete(objQueueOPList.GetLength() - 1); // remove last comma.


	CString objDigitPressList;
	for(nCount = 0; nCount < m_ctrlDigitPressList.GetItemCount(); nCount++)
	{
		sText = m_ctrlDigitPressList.GetItemText(nCount, 0);
		objDigitPressList += sText;

		if(nCount < m_ctrlDigitPressList.GetItemCount())
			objDigitPressList += ",";
	}
	objDigitPressList.Delete(objDigitPressList.GetLength() - 1); // remove last comma.


	CString objDigitPressUserList;
	for(nCount = 0; nCount < m_ctrlDigitPressList.GetItemCount(); nCount++)
	{
		sText = m_ctrlDigitPressList.GetItemText(nCount, 1);
		objDigitPressUserList += sText;

		if(nCount < m_ctrlDigitPressList.GetItemCount())
			objDigitPressUserList += ",";
	}
	objDigitPressUserList.Delete(objDigitPressUserList.GetLength() - 1); // remove last comma.

	
	CStringList objParamList;

	objParamList.AddTail(m_sQueueName);
	objParamList.AddTail(m_sQueuePlayWave);
	objParamList.AddTail(m_sDigitPressPlayWave);
	objParamList.AddTail(objQueueOPList);
	objParamList.AddTail(objDigitPressList);
	objParamList.AddTail(objDigitPressUserList);
	
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("AddQueue", &objParamList);
}


void CAddQueueDlg::OnButtonRemoveQueue() 
{
	UpdateData();
	
	if(m_sQueueName.IsEmpty())
	{
		MessageBox("Please enter queue name.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	CStringList objParamList;
	objParamList.AddTail(m_sQueueName);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("RemoveQueue", &objParamList);
}


void CAddQueueDlg::ClearDlgContent()
{
	m_ctrlListOP.ResetContent();
	
	m_sQueueName = "";
	m_sQueuePlayWave = "";
	m_sDigitPressPlayWave = "";
	
	m_ctrlDigitPressList.DeleteAllItems();
	
	UpdateData(FALSE);
}

void CAddQueueDlg::UpdateDlgContent(LPCTSTR objQueue, LPCTSTR sQueuePlayWave, LPCTSTR sDigitPressPlayWave, LPCTSTR sQueueOPList, LPCTSTR sPressDigitList, LPCTSTR sPressDigitUserList) 
{
	UpdateData();

	if(m_sQueueName != objQueue) return;
	
	m_sQueuePlayWave      = sQueuePlayWave;
	m_sDigitPressPlayWave = sDigitPressPlayWave;

	m_ctrlListOP.ResetContent();
	
	CStringList objQueueOPList;
	CStringList objPressDigitList;
	CStringList objPressDigitUserList;
		
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->ParseToStringList(sQueueOPList, &objQueueOPList);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->ParseToStringList(sPressDigitList, &objPressDigitList);
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->ParseToStringList(sPressDigitUserList, &objPressDigitUserList);

	while(!objQueueOPList.IsEmpty())
		m_ctrlListOP.AddString(objQueueOPList.RemoveHead());
	
	m_ctrlDigitPressList.DeleteAllItems();
	
	for(int nCount = 0; !objPressDigitList.IsEmpty(); nCount++)
	{
		m_ctrlDigitPressList.InsertItem(nCount, objPressDigitList.RemoveHead());
		m_ctrlDigitPressList.SetItemText(nCount, 1, objPressDigitUserList.RemoveHead());
	}
		
	UpdateData(FALSE);
}


void CAddQueueDlg::OnButtonClear() 
{
	ClearDlgContent();
}

void CAddQueueDlg::OnButtonAddLoginToQueue() 
{
	int nCurSel = m_ctrlComboLogin.GetCurSel();
	if(nCurSel == -1) return;
	
	CString sLogin;
	m_ctrlComboLogin.GetLBText(nCurSel, sLogin);
	
	if(m_ctrlListOP.FindStringExact(0, sLogin) != -1)
		return;
	
	m_ctrlListOP.AddString(sLogin);
}

void CAddQueueDlg::OnButtonRemoveLoginToQueue() 
{
	int nCurSel = m_ctrlListOP.GetCurSel();
	if(nCurSel == -1) return;

	m_ctrlListOP.DeleteString(nCurSel);
}

void CAddQueueDlg::OnSelchangeComboQueueName() 
{
	int nCurIndex = m_ctrlComboQueue.GetCurSel();
	if(nCurIndex == -1) return;

	m_ctrlComboQueue.GetLBText(nCurIndex, m_sQueueName);
		
	CStringList objParamList;
	objParamList.AddTail(m_sQueueName);

	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg->SendCommand("QueueInfo", &objParamList);
}

void CAddQueueDlg::OnButtonAddDigitDetect() 
{
	UpdateData();

	if(m_sDigitDetectPress.IsEmpty())
	{
		MessageBox("Please enter the digits press by caller.\n\n e-g: if caller press 9110 then connect call to user 9110", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	int nCount = m_ctrlComboDigitLogin.GetCurSel();
	if(nCount == -1) 
	{	
		MessageBox("Please select the login.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	LVFINDINFO ListFindInfo;
	
	ListFindInfo.flags = LVFI_STRING;
	ListFindInfo.psz = m_sDigitDetectPress;

	if(m_ctrlDigitPressList.FindItem(&ListFindInfo) != -1)
	{
		MessageBox("Digit detect " + m_sDigitDetectPress + " already exist.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	for(nCount = 0; nCount < m_ctrlDigitPressList.GetItemCount(); nCount++)
	{
		CString sDigitDetectUser = m_ctrlDigitPressList.GetItemText(nCount, 1);

		if(sDigitDetectUser == m_sDigitDetectLogin)
		{
			MessageBox("User " + m_sDigitDetectLogin + " already exist.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
			return;
		}
	}
	
	int nCurSel = m_ctrlComboDigitLogin.GetCurSel();
	if(nCurSel == -1) return;

	CString sConnectToUser; 
	m_ctrlComboDigitLogin.GetLBText(nCurSel, sConnectToUser);
		
	nCount = m_ctrlDigitPressList.GetItemCount();

	m_ctrlDigitPressList.InsertItem(nCount, m_sDigitDetectPress);
	m_ctrlDigitPressList.SetItemText(nCount, 1, sConnectToUser);
}

void CAddQueueDlg::OnButtonRemoveDigitDetect() 
{
	int nItem = m_ctrlDigitPressList.GetNextItem(-1, LVNI_SELECTED);
	if(nItem == -1)
		return;
		
	CString sItemText = m_ctrlDigitPressList.GetItemText(nItem, 0);
	m_ctrlDigitPressList.DeleteItem(nItem);
}


void CAddQueueDlg::OnDestroy() 
{
	CPropertyPage::OnDestroy();
	
	/*
	if(m_bReLoadQueues)
	{
		HANDLE hWaitEventLoadQueues = ::CreateEvent(NULL, FALSE, FALSE, RE_LOAD_QUEUES_MSG);	
	
		::SetEvent(hWaitEventLoadQueues);
		::CloseHandle(hWaitEventLoadQueues);
	}
	*/
	
}

